/*
	Briganty *.BGM
*/
#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <string.h>

unsigned long decodeLZ( FILE *in, unsigned long size, FILE *out )
{
	unsigned char	buf[256];
	unsigned char	*dic;
	unsigned long	dicpos = 0x0FEE;
	unsigned char	byte;
	unsigned char	sign;
	unsigned int	decode_startaddr;
	unsigned int	decode_length;
	int				i;
	int				q;
	unsigned long	decode_byte = 0L;
	unsigned long	read_byte = 0L;
	unsigned long	addr = 0L;

	dic = ( unsigned char * )calloc( 1, 4096 );

	while( read_byte < size )
	{
		/* compress sign */
		fread( buf, 1, 1, in ); sign = buf[0];
		read_byte++;

		for( i = 0; i != 8; i++ )
		{
			if( sign & 1 )
			{
				fread( buf, 1, 1, in ); byte = buf[0];
				dic[dicpos] = byte;
				fprintf( out, "%c", byte );
				dicpos++; dicpos &= 0x0FFF;
				read_byte++; decode_byte++;
			} else {
				fread( buf, 2, 1, in );
				decode_startaddr = buf[0] + ( buf[1] & 0xF0 ) * 0x10;
				decode_length = ( buf[1] & 0x0F ) + 3;
				read_byte += 2;

				/* decode */
				for( q = 0; q != decode_length; q++ )
				{
					addr = decode_startaddr + q; addr &= 0x0FFF;
					dic[dicpos] = dic[addr];
					fprintf( out, "%c", dic[addr] );
					dicpos++; dicpos &= 0x0FFF;
					decode_byte++;
				}
			}
			sign >>= 1;
			if( read_byte > size ) break;
		}
	}
	free( dic );
	return decode_byte;
}

void main( int ac, char **av )
{
	FILE				*in;
	FILE				*out;
	unsigned char		buf[0x10];
	unsigned long		file_ed = 0L;
	unsigned long		file_tbl[4];
	char				*file_ext[] = { ".MFM", ".MF2", ".MGS", ".MG2" };
	unsigned int		file_count = 4;
	char				filename_base[256];
	unsigned int		i;

	char				header_filename[256];
	unsigned long		header_filest = 0L;
	unsigned long		header_fileed = 0L;
	unsigned long		header_filesize = 0L;
	unsigned long		header_filesize_original = 0L;

	memset( filename_base, 0, sizeof( filename_base ));

	printf( "GIGA Briganty BGM Divider 070529 (c)Fac.KUROHANE\n" );

	if( ac == 1 )
	{
		printf( "usage: BRGDIV <filename> <output_path>\n" );
		return;
	}

	in = fopen( av[1], "rb" );
	if( in == NULL )
	{
		printf( "error: can't open %s\n", av[1] );
		return;
	}
	printf( "filename: %s\n", av[1] );

	/* filesize */
	fseek( in, 0, SEEK_END );
	file_ed = ftell( in );
	fseek( in, 0, SEEK_SET );

	printf( "fileisize: %lu(%04lX)\n",
		file_ed,
		file_ed
	);

	/* header */
	fread( buf, 0x08, 1, in );

	/* file_tbl */
	for( i = 0; i != file_count; i++ )
	{
		file_tbl[i] = *( unsigned int *)( buf + ( i * 2 )) * 16;
	}
	file_tbl[4] = file_ed;

	/* filename_base */
	memcpy( filename_base, av[1], strlen( av[1] ) - 4 );
	for( i = 0; i != file_count; i++ )
	{
		if( ac == 3 )
		{
			sprintf( header_filename, "%s%s%s",
					 av[2],
					 filename_base,
					 file_ext[i]
			);
		} else {
			sprintf( header_filename, "%s%s",
					 filename_base,
					 file_ext[i]
			);
		}

		header_filest = file_tbl[i];
		header_fileed = file_tbl[i+1];
		header_filesize = header_fileed - header_filest;

		printf( "%03d %-13s %08lX-%08lX (%lu) ",
			i + 1,
			header_filename,
			header_filest,
			header_fileed,
			header_filesize
		);

		out = fopen( header_filename, "wb+" );
		if( out == NULL )
		{
			printf( "error: can't write %s\n", header_filename );
			goto end;
		}

		/* SLZ1 extract */
		fseek( in , header_filest + 4, SEEK_SET );
		header_filesize_original = decodeLZ( in, header_filesize - 4, out );
		printf( "-> %lu(%04lX)\n",
			header_filesize_original,
			header_filesize_original
		);

		fclose( out );
	}

	printf( "\n" );
	printf( "complete.\n" );

end:;
	fclose( in );
}
